﻿
Public Class Form1

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Me.Text = AppTitleAndVersion()
        Load_INI()
        Me.WindowState = FormWindowState.Minimized
        Me.Visible = False
        TestIfStartupLinkExists()
        ShowInTaskbar = False
        InitTrayIcon()
        Refresh()
        Opacity = 1
        Timer_1sec.Interval = 1000
        Timer_1sec.Start()
        EventsAreEnabled = True
        DecodeCommandLine()
        SetButtonsStyle_Standard(Me)
        pbox_CpuUsage.Select()
        InitBreakReminder()
        ' ----------------------------------------- DEBUG
        If Debugger.IsAttached Then ShowMainWindow()
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        '
        Form2.Close()
        InitBreakReminder()
        '
        ' ------------------------------------------- DEBUG
        If Debugger.IsAttached Then
            sysTrayIcon.Dispose()
            End
        End If
        ' -------------------------------------------
        Save_INI()
        If Me.WindowState <> FormWindowState.Minimized Then
            e.Cancel = True
            Me.WindowState = FormWindowState.Minimized
            Me.Hide()
            If chk_EnableClosingMessage.Checked Then
                sysTrayIcon.ShowBalloonTip(6000, _
                                           "The application is not closed,", _
                                           "it has been moved to the tray area." & vbCr & _
                                           "Right click the Icon to exit.", _
                                           ToolTipIcon.Info)
            End If
            Return
        End If
        sysTrayIcon.Dispose()
    End Sub

    Private Sub DecodeCommandLine()
        Dim Arguments As String() = Environment.GetCommandLineArgs()
        If Arguments.Length > 1 Then
            ShowMainWindow()
            Select Case Arguments(1)
                Case "DisableAcrylicBackground" : DisableAcrylicBackground()
                Case "DisableLockScreen" : DisableLockScreen()
                Case "ResetSerialPortNumbers" : ResetSerialPortNumbers()
                Case "DeleteDesktoptIconFiles" : DeleteDesktoptIconFiles()
            End Select
        End If
    End Sub

    Private Sub ShowMainWindow()
        Opacity = 0
        Me.Show()
        WindowState = FormWindowState.Normal
        Me.Refresh()
        Me.Focus()
        Opacity = 1
        ' ------------------------------------------- Public IP
        Dim s As String = GetPublicIP()
        If s <> "" Then
            Me.Text = AppTitleAndVersion() + "        Public IP = " + s
        End If
        ' --------------------------------------------------
        Form2.Close()
        InitBreakReminder()
    End Sub

    Private Sub Form_LocationChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LocationChanged
        If Not EventsAreEnabled Then Return
        LimitFormPosition(Me)
    End Sub

    ' =======================================================================================
    '  CPU USAGE   >>> MUST BE CALLED ONE TIME EVERY SECOND <<<
    ' =======================================================================================
    Private OldCpuValue As Int32 = -1
    Private TotalCpuCounter As PerformanceCounter
    Private WithEvents AsyncTimer1 As System.Timers.Timer
    Private Sub AsyncTimer1_Elapsed(ByVal sender As Object, ByVal e As System.Timers.ElapsedEventArgs) Handles AsyncTimer1.Elapsed
        AsyncTimer1.Stop()
        TotalCpuCounter = New PerformanceCounter("Processor", "% Processor Time", "_Total")
    End Sub
    Friend Sub TestCpuUsage()
        If AsyncTimer1 Is Nothing Then
            AsyncTimer1 = New System.Timers.Timer
            AsyncTimer1.Interval = 1
            AsyncTimer1.Start()
        End If
        If chk_ShowCpuUsage.Checked Then
            If TotalCpuCounter IsNot Nothing Then
                Dim value As Single = TotalCpuCounter.NextValue
                If Me.Visible Then
                    ProgressBar_Cpu(pbox_CpuUsage, value)
                End If
                Dim NewCpuValue As Int32 = CInt(value / 20)
                If NewCpuValue <> OldCpuValue Then
                    OldCpuValue = NewCpuValue
                    Select Case NewCpuValue
                        Case 0 : sysTrayIcon.Icon = My.Resources.Cpu0
                        Case 1 : sysTrayIcon.Icon = My.Resources.Cpu1
                        Case 2 : sysTrayIcon.Icon = My.Resources.Cpu2
                        Case 3 : sysTrayIcon.Icon = My.Resources.Cpu3
                        Case 4 : sysTrayIcon.Icon = My.Resources.Cpu4
                        Case Else : sysTrayIcon.Icon = My.Resources.Cpu5
                    End Select
                End If
            End If
        Else
            sysTrayIcon.Icon = My.Resources.Watchdog3
        End If
    End Sub

    Private Sub Timer_1sec_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer_1sec.Tick
        'sysTrayIcon.Visible = Not sysTrayIcon.Visible
        TestCpuUsage()
        TestBreakReminder()
    End Sub

    ' TODO - BREAK REMINDER
    ' ================================================================
    '  BREAK REMINDER
    ' ================================================================
    Private BreakTimer As Stopwatch = New Stopwatch

    Friend Sub InitBreakReminder()
        BreakTimer.Reset()
        BreakTimer.Start()
    End Sub

    Private Sub TestBreakReminder()
        If chk_RemindToBreak.Checked Then
            If Form2.Visible Then Return
            If BreakTimer.Elapsed.TotalMinutes >= nud_BreakMinutes.Value + 0.01 Then
                My.Computer.Audio.Play(My.Resources.Question, AudioPlayMode.Background)
                BreakTimer.Stop()
                BreakTimer.Reset()
                Form2.Show(Me)

            Else
                sysTrayIcon.Text = "Theremino WinHelper - Next Break Reminder in " + _
                                   (nud_BreakMinutes.Value - CInt(BreakTimer.Elapsed.TotalMinutes)).ToString + _
                                   " minutes"
            End If
        Else
            sysTrayIcon.Text = "Theremino WinHelper"
        End If
    End Sub

    ' ================================================================
    '  TASK MANAGER
    ' ================================================================
    Private Sub btn_TaskManager_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_TaskManager.Click
        '
        ' ---------------------------------------------------------------------
        '  With this line WinApps panel could be covered by the WinHelper app.
        ' ---------------------------------------------------------------------
        'Process.Start("Taskmgr.exe") ' Task manager
        '
        ' ---------------------------------------------------------------------
        '  Ensure good Z-Order with WinApps panel in foreground
        ' ---------------------------------------------------------------------
        Try
            Me.Hide()
            Dim p As Process = New Process
            p.StartInfo.WindowStyle = ProcessWindowStyle.Normal
            p.StartInfo.FileName = "Taskmgr.exe"
            p.Start()
            'p.WaitForExit()
            Threading.Thread.Sleep(1000)
        Catch
        End Try
        Me.Show()
        Me.SendToBack()
    End Sub

    Private Sub btn_Panel_ResMonitor_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Panel_ResMonitor.Click
        Process.Start("resmon") ' Performance monitor
    End Sub

    ' ================================================================
    '  APPLICATION OPTIONS
    ' ================================================================
    Private Sub chk_StartAutomatically_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chk_StartAutomatically.CheckedChanged
        If Not EventsAreEnabled Then Return
        If chk_StartAutomatically.Checked Then
            CreateShortcutInStartUpFolder(My.Application.Info.AssemblyName)
        Else
            RemoveShortcutFromStartUpFolder(My.Application.Info.AssemblyName)
        End If
        Save_INI()
    End Sub
    Private Sub TestIfStartupLinkExists()
        Dim StartupFolder As String = Environment.GetFolderPath(Environment.SpecialFolder.Startup)
        If IO.File.Exists(StartupFolder + "\" + My.Application.Info.AssemblyName + ".lnk") Then
            chk_StartAutomatically.Checked = True
        Else
            chk_StartAutomatically.Checked = False
        End If
    End Sub
    Private Sub chk_ShowCpuUsage_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chk_ShowCpuUsage.CheckedChanged
        If Not EventsAreEnabled Then Return
        OldCpuValue = -1
        TestCpuUsage()
        Save_INI()
    End Sub
    Private Sub chk_EnableClosingMessage_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chk_EnableClosingMessage.CheckedChanged
        If Not EventsAreEnabled Then Return
        Save_INI()
    End Sub
    Private Sub chk_RemindToBreak_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chk_RemindToBreak.CheckedChanged
        If Not EventsAreEnabled Then Return
        Save_INI()
        InitBreakReminder()
    End Sub
    Private Sub nud_BreakMinutes_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles nud_BreakMinutes.ValueChanged
        If Not EventsAreEnabled Then Return
        Save_INI()
        InitBreakReminder()
    End Sub

    Private Sub btn_ClearIconCache_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_ClearIconCache.Click
        '
        ' ------------------------------------------------------------------- Reinit explorer (maybe not redoing icons)
        Try
            Process.Start("ie4uinit.exe", "-show")
        Catch
            MsgBox("Can not find the file ""ie4uinit.exe""" + vbCrLf + _
                   "Maybe this command is working on Windows10 only.")
        End Try
    End Sub

    Private Sub btn_DeleteIconFiles_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_DeleteIconFiles.Click
        '
        ' ------------------------------------------------------------------- Delete all icon files
        '
        DeleteDesktoptIconFiles()
    End Sub

    Private Sub btn_ResetSerialPortNumbers_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_ResetSerialPortNumbers.Click
        ResetSerialPortNumbers()
    End Sub

    ' ================================================================
    '  SYS TRAY ICON
    ' ================================================================
    Private WithEvents sysTrayIcon As NotifyIcon
    Private WithEvents sysTrayMenu As ContextMenuStrip

    Private Sub InitTrayIcon()
        sysTrayMenu = New ContextMenuStrip()
        With sysTrayMenu
            '.Items.Add("Properties", Nothing, AddressOf OnProps)
            .Items.Add("Exit", Nothing, AddressOf OnExit)
        End With

        sysTrayIcon = New NotifyIcon
        With sysTrayIcon
            .Text = My.Application.Info.AssemblyName
            .ContextMenuStrip = sysTrayMenu
            .Icon = My.Resources.Cpu0
            .Visible = True
        End With
    End Sub

    Friend Sub HideTrayIcon()
        sysTrayIcon.Visible = False
    End Sub

    Private Sub OnExit(ByVal sender As Object, ByVal e As EventArgs)
        WindowState = FormWindowState.Minimized
        Close()
    End Sub

    Private Sub sysTrayIcon_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles sysTrayIcon.MouseDown
        If e.Button = Windows.Forms.MouseButtons.Left Then
            If Me.WindowState <> FormWindowState.Minimized Then
                Me.Hide()
                Me.WindowState = FormWindowState.Minimized
            Else
                ShowMainWindow()
            End If
            Form2.Close()
            InitBreakReminder()
        End If
    End Sub



    ' ================================================================
    '  BUTTONS - WIN 10 TWEAKS
    ' ================================================================
    Private Sub btn_ShowAllIcons_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles btn_ShowAllIcons.MouseDown
        ShowAllIcons()
    End Sub
    Private Sub btn_LinkOff_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles btn_LinkOff.MouseDown
        LinkKeyword_OFF()
    End Sub
    Private Sub btn_DisableWindowsDocking_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles btn_DisableWindowsDocking.MouseDown
        DisableWindowsArranging()
    End Sub
    Private Sub btn_DisableBlur_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles btn_DisableBlur.MouseDown
        DisableAcrylicBackground()
    End Sub
    Private Sub btn_DisableLockScreen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_DisableLockScreen.Click
        DisableLockScreen()
    End Sub


    ' ================================================================
    '  BUTTONS - MIXED UTILS
    ' ================================================================
    Private Sub btn_OpenUserStartupFolder_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_OpenUserStartupFolder.Click
        Process.Start("shell:startup")                                               ' Open the user startup folder
        'Process.Start(Environment.GetFolderPath(Environment.SpecialFolder.Startup)) ' Open the user startup folder
    End Sub
    Private Sub btn_OpenSystemStartupFolder_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_OpenSystemStartupFolder.Click
        Process.Start("shell:common startup")      ' Open the system startup folder
        'Process.Start("ms-settings:defaultapps")  ' Open the system startup folder
    End Sub
    Private Sub btn_StartupApps_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_StartupApps.Click
        Process.Start("ms-settings:startupapps")  ' All the application in automatic startup mode
    End Sub
    Private Sub btn_OpenApplicationsFolder_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_OpenApplicationsFolder.Click
        Process.Start("shell:appsfolder")   ' The HIDDEN APPLICATION FOLDER (useful to get links to impossible to link applications)
    End Sub

    ' ================================================================
    '  BUTTONS - USEFUL PANELS
    ' ================================================================
    Private Sub btn_Panel_UninstallApps_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Panel_UninstallApps.Click
        Process.Start("appwiz.cpl") ' Uninstall applications
    End Sub
    Private Sub btn_Panel_UnunstallWinApps_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Panel_UnunstallWinApps.Click
        '
        ' ---------------------------------------------------------------------
        '  With this line WinApps panel could be covered by the WinHelper app.
        ' ---------------------------------------------------------------------
        'Process.Start("RunDLL32.EXE", "shell32.dll,Control_RunDLL appwiz.cpl,,2") ' Uninstall windows components
        '
        ' ---------------------------------------------------------------------
        '  Ensure good Z-Order with WinApps panel in foreground
        ' ---------------------------------------------------------------------
        Me.Hide()
        Dim p As Process = New Process
        p.StartInfo.WindowStyle = ProcessWindowStyle.Normal
        p.StartInfo.FileName = "RunDLL32.EXE"
        p.StartInfo.Arguments = "shell32.dll,Control_RunDLL appwiz.cpl,,2"
        p.Start()
        p.WaitForExit()
        Threading.Thread.Sleep(1000)
        Me.Show()
        Me.SendToBack()
    End Sub
    Private Sub btn_Panel_WinVersion_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Panel_WinVersion.Click
        'Process.Start("C:\WINDOWS\system32\winver.exe") ' Windows version
        Process.Start("winver") ' Windows version
    End Sub
    Private Sub btn_Panel_WinUpdate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Panel_WinUpdate.Click
        'Process.Start("ms-settings:windowsupdate?activationSource=SMC-Article-12373")
        'Process.Start("ms-settings:windowsupdate-action")
        Process.Start("ms-settings:windowsupdate")
    End Sub


    Private Sub btn_Panel_ControlPanel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Panel_ControlPanel.Click
        Process.Start("control.exe") ' Control panel
    End Sub
    Private Sub btn_Panel_DevManager_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Panel_DevManager.Click
        Process.Start("devmgmt.msc")
    End Sub
    Private Sub btn_Panel_Audio_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Panel_Audio.Click
        Process.Start("RunDLL32.EXE", "shell32.dll,Control_RunDLL mmsys.cpl,,0") ' Audio Play
        'Process.Start("RunDLL32.EXE", "shell32.dll,Control_RunDLL mmsys.cpl,,1") ' Audio Record
        'Process.Start("RunDLL32.EXE", "shell32.dll,Control_RunDLL mmsys.cpl,,2") ' Audio Sounds
        'Process.Start("RunDLL32.EXE", "shell32.dll,Control_RunDLL mmsys.cpl,,3") ' Audio Communications
        'Process.Start("RunDLL32.EXE", "shell32.dll,Control_RunDLL mmsys.cpl,,4") ' Audio Hardware
    End Sub
    Private Sub btn_Panel_DesktopIcons_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Panel_DesktopIcons.Click
        'Process.Start("RunDLL32.EXE", "shell32.dll,Control_RunDLL desk.cpl,,1") ' Dektop icons
        Process.Start("desk.cpl", ",,1") ' Dektop icons
    End Sub
    Private Sub btn_Panel_TaskbarOptions_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Panel_TaskbarOptions.Click
        Process.Start("RunDLL32.EXE", "shell32.dll,Options_RunDLL 1") ' Taskbar options
    End Sub
    Private Sub btn_Panel_MouseOptions_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Panel_MouseOptions.Click
        Process.Start("ms-settings:mousetouchpad") ' Mouse options
    End Sub
    Private Sub btn_Panel_PowerOptions_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Panel_PowerOptions.Click
        Process.Start("powercfg.cpl") ' Power options
        'Process.Start("RunDLL32.EXE", "Shell32.dll,Control_RunDLL powercfg.cpl") ' Power options
    End Sub
    Private Sub btn_Panel_LoginPassword_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Panel_LoginPassword.Click
        Process.Start("netplwiz")
    End Sub
    Private Sub btn_Panel_SystemProtection_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Panel_SystemProtection.Click
        Process.Start("RunDLL32.EXE", "shell32.dll,Control_RunDLL sysdm.cpl,,4")
    End Sub
    Private Sub btn_ShowThumbnails_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_ShowThumbnails.Click
        Process.Start("RunDLL32.EXE", "shell32.dll,Options_RunDLL 7") ' Explore file VIEW-OPTIONS
    End Sub


    ' ================================================================
    '  BUTTONS - WALLPAPERS
    ' ================================================================
    Private Sub btn_Wallpaper1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Wallpaper1.Click
        SetWallpaper("Wallpaper1.jpg")
    End Sub
    Private Sub btn_Wallpaper2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Wallpaper2.Click
        SetWallpaper("Wallpaper2.jpg")
    End Sub
    Private Sub btn_Wallpaper3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Wallpaper3.Click
        SetWallpaper("Wallpaper3.jpg")
    End Sub
    Private Sub btn_Wallpaper_ChooseImages_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Wallpaper_ChooseImages.Click
        ChooseWallpaper()
    End Sub
    Private Sub btn_Wallpaper_ChooseColors_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Wallpaper_ChooseColors.Click
        'Process.Start("C:\WINDOWS\system32\control.exe", "color") ' Background images or colors
        Process.Start("RunDLL32.EXE", "shell32.dll,Control_RunDLL desk.cpl,,2") ' Background images or colors
    End Sub
    Private Sub btn_Wallpaper_ChooseScreensaver_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Wallpaper_ChooseScreensaver.Click
        'Process.Start("C:\Windows\System32\control.exe", "desk.cpl,screensaver,@screensaver")
        Process.Start("RunDLL32.EXE", "shell32.dll,Control_RunDLL desk.cpl,,1")
    End Sub

End Class
