﻿Module ButtonsStyleStandard

    ' ----------------------------------------------------------------------------------
    '  The style Standard has the best visibility but the hover color is not working
    ' ----------------------------------------------------------------------------------
    '  Call the sub "SetButtonsStyle_Standard" with a control as parameter
    '  Normally call from the Form1.Load as this example: SetButtonsStyle_Standard(Me)
    ' ----------------------------------------------------------------------------------
    '  All buttons in the control are set with the Standard Style
    '  The "Hover" colors are changed in the events MouseEnter and MouseLeave
    ' ----------------------------------------------------------------------------------

    Dim ColorDefault As Color = Color.FromArgb(230, 230, 230)
    Dim ColorHover As Color = Color.FromArgb(245, 245, 240)

    Friend Sub SetButtonsStyle_Standard(ByVal ctrl As Control)
        For Each c As Control In ctrl.Controls
            If TypeOf (c) Is Button Then
                Dim b As Button = CType(c, Button)
                b.FlatStyle = FlatStyle.Standard
                b.BackColor = ColorDefault
                AddHandler c.MouseEnter, AddressOf All_Button_Hover_MouseEnter
                AddHandler c.MouseLeave, AddressOf All_Button_Hover_MouseLeave
            End If
            If c.Controls.Count > 0 Then
                SetButtonsStyle_Standard(c)
            End If
        Next
    End Sub

    Private Sub All_Button_Hover_MouseEnter(ByVal sender As Object, ByVal e As EventArgs)
        Dim b As Button = CType(sender, Button)
        b.BackColor = ColorHover
    End Sub

    Private Sub All_Button_Hover_MouseLeave(ByVal sender As Object, ByVal e As EventArgs)
        Dim b As Button = CType(sender, Button)
        b.BackColor = ColorDefault
        Form1.GroupBox1.Select()
    End Sub

End Module
