﻿Module Module_FillBars

    ' =======================================================================================
    '   ProgressBar_Cpu
    ' =======================================================================================
    Friend Sub ProgressBar_Cpu(ByVal pbox As PictureBox, ByVal PercentualCPU As Double)
        '
        If pbox.Image Is Nothing Then
            InitPictureboxImage(pbox)
        End If
        '
        If PercentualCPU < 0 Then PercentualCPU = 0
        If PercentualCPU > 100 Then PercentualCPU = 100
        '
        Dim r As Rectangle
        r.X = 0
        r.Y = 0
        r.Width = CInt(pbox.Width / 2) - 1   ' <--- (-1) to correct the vertical green line in the middle
        r.Height = pbox.Height
        Dim b1 As Drawing2D.LinearGradientBrush = New Drawing2D.LinearGradientBrush(r, _
                                                                            Color.FromArgb(100, 255, 0), _
                                                                            Color.FromArgb(255, 200, 0), _
                                                                            Drawing2D.LinearGradientMode.Horizontal)
        Dim b2 As Drawing2D.LinearGradientBrush = New Drawing2D.LinearGradientBrush(r, _
                                                                            Color.FromArgb(255, 200, 0), _
                                                                            Color.FromArgb(255, 0, 0), _
                                                                            Drawing2D.LinearGradientMode.Horizontal)
        '
        Dim v As Int32 = CInt((PercentualCPU * pbox.Width) / 100)
        Dim vmid As Int32 = CInt(pbox.Width / 2)
        '
        ' ----------------------------------------------------------- using "Graphics.FromImage" for best performance
        Dim g As Graphics = Graphics.FromImage(pbox.Image)

        If PercentualCPU <= 50 Then
            g.FillRectangle(b1, 0, 0, v, pbox.ClientSize.Height)
        Else
            g.FillRectangle(b1, 0, 0, vmid, pbox.ClientSize.Height)
            g.FillRectangle(b2, vmid, 0, v - vmid, pbox.ClientSize.Height)
        End If
        Dim b As Brush = New SolidBrush(pbox.BackColor)
        g.FillRectangle(b, v, 0, pbox.ClientSize.Width - v, pbox.ClientSize.Height)
        '
        Dim f As Font = New Font("Tahoma", pbox.ClientSize.Height - 2, FontStyle.Regular, GraphicsUnit.Pixel)
        g.TextRenderingHint = Drawing.Text.TextRenderingHint.AntiAliasGridFit
        g.DrawString(Str(Int(PercentualCPU)) & "%", f, Brushes.Black, CInt(pbox.Width / 2 - 17), -2)
        '
        ' ----------------------------------------------------------- final refresh - no flickering
        pbox.Refresh()
    End Sub

    ' =======================================================================================
    '  Utils
    ' =======================================================================================
    Friend Sub InitPictureboxImage(ByVal pbox As PictureBox)
        With pbox
            If .ClientSize.Height < 1 Then Return
            .Image = New Bitmap(.ClientSize.Width, .ClientSize.Height)
        End With
    End Sub

End Module

