﻿
Imports System.Net
Imports System.Net.NetworkInformation
Imports System.Text.RegularExpressions

Module Module_NetworkInfo

    Private Class MyWebClient
        Inherits WebClient
        Protected Overrides Function GetWebRequest(ByVal uri As Uri) As WebRequest
            Dim w As WebRequest = MyBase.GetWebRequest(uri)
            w.Timeout = 1000 ' milliseconds
            Return w
        End Function
    End Class

    Private Function GetPublicIP_WithTimeout(ByVal url As String) As String
        Dim s As String = ""
        Try
            Dim WCL As New MyWebClient
            s = WCL.DownloadString(url)
        Catch
        End Try
        Return s
    End Function

    Friend Function GetPublicIP() As String
        Dim s As String = ""
        s = GetPublicIP_WithTimeout("https://ipinfo.io/ip")
        If s <> "" Then Return s
        s = GetPublicIP_WithTimeout("https://ifconfig.me/ip")
        If s <> "" Then Return s
        s = GetPublicIP_WithTimeout("https://icanhazip.com")
        If s <> "" Then Return s
        s = GetPublicIP_WithTimeout("https://ident.me")
        If s <> "" Then Return s
        s = GetPublicIP_WithTimeout("https://smart-ip.net/myip")
        If s <> "" Then Return s
        s = GetPublicIP_WithTimeout("https://api.my-ip.io/ip")
        If s <> "" Then Return s
        s = GetPublicIP_WithTimeout("https://api.my-ip.io/ip.txt")
        Return s
    End Function

    ' ================================================================================================
    '   LOCAL IP - UNFINISHED
    ' ================================================================================================
    'Friend Sub GetLocalIP_1()
    '    Dim LocalIPList As IPHostEntry = Dns.GetHostEntry(Environment.MachineName)
    '    For Each LocalIP As IPAddress In LocalIPList.AddressList
    '        If LocalIP.AddressFamily = Sockets.AddressFamily.InterNetwork Then
    '            MessageBox.Show(LocalIP.ToString)
    '        End If
    '    Next
    'End Sub

    'Friend Sub GetLocalIP_2()
    '    Dim nics As NetworkInformation.NetworkInterface() = NetworkInterface.GetAllNetworkInterfaces()
    '    For Each nic As NetworkInformation.NetworkInterface In nics
    '        Dim props As NetworkInformation.IPInterfaceProperties = nic.GetIPProperties
    '        For Each address As NetworkInformation.UnicastIPAddressInformation In props.UnicastAddresses
    '            If address.Address.AddressFamily = Net.Sockets.AddressFamily.InterNetwork Then
    '                MessageBox.Show(address.Address.ToString)
    '            End If
    '        Next
    '    Next
    'End Sub

End Module
